Module org.jfree.chart3d
Package org.jfree.chart3d.renderer.xyz

# Interface XYZRenderer

All Superinterfaces:
  `ChartElement`, `Renderer3D`

All Known Implementing Classes:
  `BarXYZRenderer`, `LineXYZRenderer`, `ScatterXYZRenderer`, `SurfaceRenderer`

public interface XYZRenderer extends Renderer3D
A renderer that can display data from an `XYZDataset` on an `XYZPlot`.

## Field Summary

### Fields inherited from interface org.jfree.chart3d.renderer.Renderer3D

`TRANSPARENT_COLOR`

## Method Summary

Modifier and Type
Method
Description
`void`
`composeAll(XYZPlot plot, World world, Dimension3D dimensions, double xOffset, double yOffset, double zOffset)`
Composes all the 3D objects that this renderer needs to present.
`void`
`composeItem(XYZDataset dataset, int series, int item, World world, Dimension3D dimensions, double xOffset, double yOffset, double zOffset)`
Constructs and places one item from the specified dataset into the given world.
`Range`
`findXRange(XYZDataset dataset)`
Returns the range that should be set on the x-axis in order for this renderer to be able to display all the data in the supplied dataset.
`Range`
`findYRange(XYZDataset dataset)`
Returns the range that should be set on the y-axis in order for this renderer to be able to display all the data in the supplied dataset.
`Range`
`findZRange(XYZDataset dataset)`
Returns the range that should be set on the z-axis in order for this renderer to be able to display all the data in the supplied dataset.
`XYZColorSource`
`getColorSource()`
Returns the color source for the renderer, which is an object that is responsible for providing the colors used by the renderer to draw data (and legend) items.
`ComposeType`
`getComposeType()`
Returns the type of composition performed by the renderer.
`XYZPlot`
`getPlot()`
Returns the plot that this renderer is assigned to.
`void`
`setColors(Color... colors)`
Sets the colors for the renderer.
`void`
`setColorSource(XYZColorSource source)`
Sets the color source for the renderer and sends a `Renderer3DChangeEvent` to all registered listeners.
`void`
`setPlot(XYZPlot plot)`
Sets the plot that the renderer is assigned to.

### Methods inherited from interface org.jfree.chart3d.ChartElement

`receive`

### Methods inherited from interface org.jfree.chart3d.renderer.Renderer3D

`addChangeListener, removeChangeListener`

## Method Details

### getPlot

XYZPlot getPlot()
Returns the plot that this renderer is assigned to.

Returns:
  The plot (possibly `null`).

### setPlot

void setPlot(XYZPlot plot)
Sets the plot that the renderer is assigned to. Although this method is part of the public API, client code should not need to call it.

Parameters:
  `plot` - the plot (`null` permitted).

### getColorSource

XYZColorSource getColorSource()
Returns the color source for the renderer, which is an object that is responsible for providing the colors used by the renderer to draw data (and legend) items.

Returns:
  The paint source (never `null`).

### setColorSource

void setColorSource(XYZColorSource source)
Sets the color source for the renderer and sends a `Renderer3DChangeEvent` to all registered listeners.

Parameters:
  `source` - the color source (`null` not permitted).
Since:
  1.2

### setColors

void setColors(Color... colors)
Sets the colors for the renderer.

Parameters:
  `colors` - the colors.
Since:
  1.2

### findXRange

Range findXRange(XYZDataset dataset)
Returns the range that should be set on the x-axis in order for this renderer to be able to display all the data in the supplied dataset. If the dataset contains no data, this method returns `null`.

Parameters:
  `dataset` - the dataset (`null` not permitted).
Returns:
  The range (possibly `null`).

### findYRange

Range findYRange(XYZDataset dataset)
Returns the range that should be set on the y-axis in order for this renderer to be able to display all the data in the supplied dataset. If the dataset contains no data, this method returns `null`.

Parameters:
  `dataset` - the dataset (`null` not permitted).
Returns:
  The range.

### findZRange

Range findZRange(XYZDataset dataset)
Returns the range that should be set on the z-axis in order for this renderer to be able to display all the data in the supplied dataset. If the dataset contains no data, this method returns `null`.

Parameters:
  `dataset` - the dataset (`null` not permitted).
Returns:
  The range.

### getComposeType

ComposeType getComposeType()
Returns the type of composition performed by the renderer. This determines whether the plot will call the `composeItem()` method (once for each data item) or just call the `composeAll()` method once.

Returns:
  The type of composition (never `null`).
Since:
  1.1

### composeItem

void composeItem(XYZDataset dataset, int series, int item, World world, Dimension3D dimensions, double xOffset, double yOffset, double zOffset)
Constructs and places one item from the specified dataset into the given world. The `XYZPlot` class will iterate over its dataset and and call this method for each item (in other words, you don't need to call this method directly).

Parameters:
  `dataset` - the dataset (`null` not permitted).
  `series` - the series index.
  `item` - the item index.
  `world` - the world (`null` not permitted).
  `dimensions` - the dimensions (`null` not permitted).
  `xOffset` - the x-offset.
  `yOffset` - the y-offset.
  `zOffset` - the z-offset.

### composeAll

void composeAll(XYZPlot plot, World world, Dimension3D dimensions, double xOffset, double yOffset, double zOffset)
Composes all the 3D objects that this renderer needs to present. This method only needs to be implemented if the `getComposeType()` method returns `ALL`, otherwise it can be left empty.

Parameters:
  `plot` - the plot.
  `world` - the world (`null` not permitted).
  `dimensions` - the dimensions (`null` not permitted).
  `xOffset` - the x-offset.
  `yOffset` - the y-offset.
  `zOffset` - the z-offset.
Since:
  1.1